<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

-<template>
  <div>
    <div
      v-if="isLoader"
      class="m-loader m-loader--brand m-loader--lg"
      style="width: 30px; height: 30px; display: inline-block;"
    ></div>
    <div v-else>
      <div class="text-right m--margin-bottom-20">
        <button
          data-toggle="modal"
          data-target="#add_attribute_custom"
          class="nt-button nt-button-secondary nt-button-small d-inline-block"
        >
          <i class="la la-plus"></i> Thêm trường dữ liệu
        </button>
      </div>
      <div class="table-responsive nt-scroll-primary">
        <table
          class="table table-bordered table-hover s--table s--table-attribute-customer-settings nt-table-list"
          v-if="attributeCustom.length > 0"
        >
          <thead>
            <tr>
              <th class="action">Tác vụ</th>
              <th class="name">Tên trường dữ liệu</th>
              <th class="customer_type">Hiển thị trong màn hình Xem chi tiết khách hàng ở tab</th>
              <!--<th class="alias">Tên trường khi gán biến</th>-->
              <th class="type">Kiểu điền dữ liệu</th>
              <th class="required">Bắt buộc</th>
              <th class="unique">Không cho trùng</th>
              <th class="on_off">Ẩn/hiện trường tùy chỉnh</th>
            </tr>
          </thead>

          <!--<draggable element="tbody" :options="{draggable:'.item-drag&#45;&#45;table',forceFallback: true }">-->
          <tbody>
            <tr v-for="(attribute, index) in attributeCustom" :key="index" class="item-drag--table">
              <td class="text-center action">
                <button
                  class="btn m-btn m-btn--icon m-btn--icon-only m-btn--pill"
                  aria-expanded="false"
                  aria-haspopup="true"
                  data-toggle="dropdown"
                >
                  <i class="la la-ellipsis-h"></i>
                </button>
                <div class="dropdown-menu">
                  <button
                    @click.prevent="showModalEdit(index)"
                    :data-target="'#edit_attribute_custom'"
                    class="dropdown-item s--cursor-pointer"
                  >
                    <i class="la la-pencil"></i>Chỉnh sửa
                  </button>
                  <template>
                    <button
                      @click.prevent="showModalDelete(index)"
                      class="dropdown-item s--cursor-pointer"
                    >
                      <i class="la la-trash"></i>Xóa
                    </button>
                  </template>
                </div>
              </td>
              <td class="name">
                <!--<a href="" @click.prevent="isCurrentEdit = true" data-toggle="modal" :data-target="'#updateAttributeCustomerSetting' + attribute.id" class="m-link nt-link m-link&#45;&#45;primary"></a>-->
                {{ attribute.attribute_name }}
              </td>
              <td class="customer_type">
                <template
                  v-if="attribute.show_position == CUSTOMER_DETAIL_BOX_GENERAL"
                >Thông tin chung</template>
                <template
                  v-if="attribute.show_position == CUSTOMER_DETAIL_BOX_BUY"
                >Thông tin dành cho người mua hàng</template>
                <template
                  v-if="attribute.show_position == CUSTOMER_DETAIL_BOX_USE"
                >Thông tin dành cho người sử dụng cuối</template>
              </td>
              <!--<td class="alias">{{ attribute.attribute_code }}</td>-->
              <td class="type" v-if="attribute.data_type">{{ attribute.data_type.data_type_name }}</td>

              <td class="required text-center">
                <span class="m-switch m-switch--outline m-switch--success">
                  <label
                    @click.prevent="showModalChangeRequired(index)"
                    :class="{ 's--disabled-checkbox': attribute.data_type_id == isRadio }"
                  >
                    <template v-if="attribute.is_required">
                      <input
                        type="checkbox"
                        :value="attribute.is_required"
                        checked
                        :id="'custom_attribute_required' + attribute.id"
                        :name="'custom_attribute_required' + attribute.id"
                        :disabled="attribute.data_type_id == isRadio"
                      />
                    </template>
                    <template v-else>
                      <input
                        :value="attribute.is_required"
                        :id="'custom_attribute_required' + attribute.id"
                        :name="'custom_attribute_required' + attribute.id"
                        :disabled="attribute.data_type_id == isRadio"
                      />
                    </template>

                    <span></span>
                  </label>
                </span>
              </td>
              <td class="unique text-center">
                <span class="m-switch m-switch--outline m-switch--success">
                  <label
                    @click.prevent="showModalChangeUnique(index)"
                    :class="{ 's--disabled-checkbox': (attribute.data_type_id != isText && attribute.data_type_id != isEmail && attribute.data_type_id != isPhone) }"
                  >
                    <template v-if="attribute.is_unique">
                      <input
                        type="checkbox"
                        :value="attribute.is_unique"
                        checked
                        :id="'custom_attribute_unique' + attribute.id"
                        :name="'custom_attribute_unique' + attribute.id"
                        :disabled="attribute.data_type_id != isText && attribute.data_type_id != isEmail && attribute.data_type_id != isPhone"
                      />
                    </template>
                    <template v-else>
                      <input
                        :value="attribute.is_unique"
                        :id="'custom_attribute_unique' + attribute.id"
                        :name="'custom_attribute_unique' + attribute.id"
                        :disabled="attribute.data_type_id != isText && attribute.data_type_id != isEmail && attribute.data_type_id != isPhone"
                      />
                    </template>
                    <span></span>
                  </label>
                </span>
              </td>
              <td class="on_off">
                <span class="m-switch m-switch--outline m-switch--success">
                  <label @click.prevent="showModalChangeHideShow(index)">
                    <template v-if="!attribute.is_hidden">
                      <input
                        type="checkbox"
                        :value="attribute.is_hidden"
                        checked
                        :id="'custom_attribute_show_hide' + attribute.id"
                        :name="'custom_attribute_show_hide' + attribute.id"
                      />
                    </template>

                    <template v-else>
                      <input
                        :value="attribute.is_hidden"
                        :id="'custom_attribute_show_hide' + attribute.id"
                        :name="'custom_attribute_show_hide' + attribute.id"
                      />
                    </template>

                    <span></span>
                  </label>
                </span>
                <!--<div class="icon-sort">
                                    <span></span>
                                    <span></span>
                                    <span></span>
                                    <span></span>
                                    <span></span>
                                    <span></span>
                                    <span></span>
                                    <span></span>
                </div>-->
              </td>
            </tr>
          </tbody>
          <!--</draggable>-->
        </table>

        <div v-else class="text-center m--padding-bottom-20">Không có trường tùy chỉnh nào.</div>
      </div>

      <!--Delete Attribute-->
      <div
        v-if="attributeCustom.length > 0 && indexDeleteCustomAttribute != null"
        data-backdrop="static"
        data-keyboard="false"
        class="modal s--modal fade nt--modal-confirm-choice s--modal-delete-custom-attribute"
      >
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-body">
              <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
              <!--Thông báo-->
              <!--</h3>-->
              <div class="nt--modal-confirm-choice-content">
                <div
                  class="nt--modal-confirm-choice-content-title-top"
                  v-if="attributeCustom[indexDeleteCustomAttribute]"
                >
                  Xóa trường
                  <span
                    class="nt-color-warning"
                  >{{ attributeCustom[indexDeleteCustomAttribute].attribute_name }}</span>?
                </div>
                <div
                  class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                >Tất cả dữ liệu trường thông tin này đã lưu sẽ bị xóa, và bạn không thể lấy lại dữ liệu này.</div>
              </div>
            </div>
            <div class="modal-footer">
              <button
                class="nt-button nt-button-secondary mr-2"
                data-dismiss="modal"
                aria-label="Close"
              >Hủy bỏ</button>
              <button
                @click.prevent="deleteCustomerAttribute(attributeCustom[indexDeleteCustomAttribute])"
                class="nt-button nt-button-warning mr-0"
                data-dismiss="modal"
              >Xóa</button>
            </div>
          </div>
        </div>
      </div>

      <!--Change required attribute-->
      <div
        v-if="attributeCustom.length > 0 && indexChangeRequiredCustomAttribute != null"
        data-backdrop="static"
        data-keyboard="false"
        class="modal s--modal fade nt--modal-confirm-choice s--modal-change-required-custom-attribute"
      >
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-body">
              <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
              <!--Thông báo-->
              <!--</h3>-->
              <div class="nt--modal-confirm-choice-content">
                <template v-if="!attributeCustom[indexChangeRequiredCustomAttribute].is_required">
                  <div class="nt--modal-confirm-choice-content-title-top">
                    Trường
                    <span
                      class="nt-color-warning"
                    >{{ attributeCustom[indexChangeRequiredCustomAttribute].attribute_name }}</span> sẽ chuyển thành bắt buộc điền?
                  </div>
                  <div
                    class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                  >Khi thêm khách hàng, sửa thông tin khách hàng, sẽ bắt buộc điền dữ liệu cho trường này.</div>
                </template>

                <template v-else>
                  <div class="nt--modal-confirm-choice-content-title-top">
                    Trường
                    <span
                      class="nt-color-warning"
                    >{{ attributeCustom[indexChangeRequiredCustomAttribute].attribute_name }}</span> sẽ chuyển thành không bắt buộc điền?
                  </div>
                  <div
                    class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                  >Khi thêm khách hàng, sửa thông tin khách hàng, sẽ không bắt buộc điền dữ liệu cho trường này.</div>
                </template>
              </div>
            </div>
            <div class="modal-footer">
              <button
                class="nt-button nt-button-secondary mr-2"
                data-dismiss="modal"
                aria-label="Close"
              >Hủy bỏ</button>
              <button
                @click.prevent="requiredAttributeItem(attributeCustom[indexChangeRequiredCustomAttribute])"
                class="nt-button nt-button-warning mr-0"
                data-dismiss="modal"
              >Đồng ý</button>
            </div>
          </div>
        </div>
      </div>

      <!--Change unique attribute-->
      <div
        v-if="attributeCustom.length > 0 && indexChangeUniqueCustomAttribute != null"
        data-backdrop="static"
        data-keyboard="false"
        class="modal s--modal fade nt--modal-confirm-choice s--modal-change-unique-custom-attribute"
      >
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-body">
              <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
              <!--Thông báo-->
              <!--</h3>-->
              <div class="nt--modal-confirm-choice-content">
                <template v-if="!attributeCustom[indexChangeUniqueCustomAttribute].is_unique">
                  <div class="nt--modal-confirm-choice-content-title-top">
                    Trường
                    <span
                      class="nt-color-warning"
                    >{{ attributeCustom[indexChangeUniqueCustomAttribute].attribute_name }}</span> sẽ cho trùng dữ liệu?
                  </div>
                  <div
                    class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                  >Khi thêm khách hàng, sửa thông tin khách hàng, trường này sẽ kiểm tra dữ liệu và không cho phép trùng.</div>
                </template>

                <template v-else>
                  <div class="nt--modal-confirm-choice-content-title-top">
                    Trường
                    <span
                      class="nt-color-warning"
                    >{{ attributeCustom[indexChangeUniqueCustomAttribute].attribute_name }}</span> sẽ không cho trùng dữ liệu?
                  </div>
                  <div
                    class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                  >Khi thêm khách hàng, sửa thông tin khách hàng, trường này sẽ không kiểm tra dữ liệu có trùng hay không.</div>
                </template>
              </div>
            </div>
            <div class="modal-footer">
              <button
                class="nt-button nt-button-secondary mr-2"
                data-dismiss="modal"
                aria-label="Close"
              >Hủy bỏ</button>
              <button
                @click.prevent="uniqueAttributeItem(attributeCustom[indexChangeUniqueCustomAttribute])"
                class="nt-button nt-button-warning mr-0"
                data-dismiss="modal"
              >Đồng ý</button>
            </div>
          </div>
        </div>
      </div>

      <!--Change show hide attribute-->
      <div
        v-if="attributeCustom.length > 0 && indexChangeShowHideCustomAttribute != null"
        data-backdrop="static"
        data-keyboard="false"
        class="modal s--modal fade nt--modal-confirm-choice s--modal-change-show-hide-custom-attribute"
      >
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-body">
              <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
              <!--Thông báo-->
              <!--</h3>-->
              <div class="nt--modal-confirm-choice-content">
                <template v-if="!attributeCustom[indexChangeShowHideCustomAttribute].is_hidden">
                  <div class="nt--modal-confirm-choice-content-title-top">
                    Ẩn trường
                    <span
                      class="nt-color-warning"
                    >{{ attributeCustom[indexChangeShowHideCustomAttribute].attribute_name }}</span>?
                  </div>
                  <div
                    class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                  >Trường này sẽ không hiển thị trong các màn hình Danh sách khách hàng, Sửa thông tin khách hàng, Xem chi tiết khách hàng.</div>
                </template>

                <template v-else>
                  <div class="nt--modal-confirm-choice-content-title-top">
                    Hiện trường
                    <span
                      class="nt-color-warning"
                    >{{ attributeCustom[indexChangeShowHideCustomAttribute].attribute_name }}</span>?
                  </div>
                  <div
                    class="nt--modal-confirm-choice-content-title-bottom nt-color-warning"
                  >Trường này sẽ hiển thị trong các màn hình Danh sách khách hàng, Sửa thông tin khách hàng, Xem chi tiết khách hàng.</div>
                </template>
              </div>
            </div>
            <div class="modal-footer">
              <button
                class="nt-button nt-button-secondary mr-2"
                data-dismiss="modal"
                aria-label="Close"
              >Hủy bỏ</button>
              <button
                @click.prevent="showHideAttributeItem(attributeCustom[indexChangeShowHideCustomAttribute])"
                class="nt-button nt-button-warning mr-0"
                data-dismiss="modal"
              >
                <template v-if="!attributeCustom[indexChangeShowHideCustomAttribute].is_hidden">Ẩn</template>
                <template v-else>Hiện</template>
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <edit-attribute-custom
      v-if="attributeSelectItem != null"
      :attribute="attributeSelectItem"
      @is_cancel="isCancel"
      @is_success="isSuccess"
    ></edit-attribute-custom>
    <add-attribute-custom @is_success="isSuccess"></add-attribute-custom>
  </div>
</template>
